Change Log
----------
Version 5.5.0:
- bug fixes
- General
  -- added Portugese translations provided by Candido Fontes
- Multi Project
  -- changed multi project file format to contain relative paths to
     the contained project files
- Project Forms Browser
  -- added functionality to modify some form code creation options (see
     Qt configuration page)
- Web Browser
  -- added DuckDuckGo to the list of default search engines

Version 5.5-snapshot-20140628:
- bug fixes
- General
  -- changed the eric mascot to be a Python (i.e. the snake). New icons
     and pixmaps provided by Thimo Kraemer.
  -- changed the code to be executed with Python 2 as well (thanks to
     Tobias Rzepka)
  -- implemented a background service which execute Python2 and Python3 scripts
     in the background independent of the current interpreter
- Checkers
  -- updated pep8 to 1.5.6
  -- updated pyflakes to version 0.8.1 (Python 3.4.0 compatible)
  -- added syntax checker for JavaScript files
  -- added capability to check multiple files from the project sources browser
- Debugger
  -- updated coverage to 3.7.1
  -- enabled coverage info in Python2 projects
- Editor
  -- added a scrolling map like display showing all markers
  -- added a context menu entry to reload a file with a given encoding
  -- added a lexer for Qt style sheet files (when upgrading from older
     eric versions a change of the lexer association for *.qss files needs
     to be done via the configuration dialog)
  -- added support for the QScintilla Gettext lexer (QsciLexerPO) as of
     QScintilla 2.8.2
  -- added support for the QScintilla CoffeeScript lexer
     (QsciLexerCoffeeScript) as of QScintilla 2.8.3
- Multi Project
  -- added support for the categorisation of projects and changed the
     multi project file format
- Plugin Manager
  -- extended the plugin repository dialog to allow to hide unwanted entries
     and cleanup the plugin downloads area
  -- implemented the Python2 compatibility check for plug-ins (new boolean flag
     'python2Compatible'
- Project
  -- added support for JavaScript projects
  -- added code to move deleted files/directories to the recycle bin falling
     back to removing them (os.remove), if send2trash cannot be imported due
     to missing dependencies
- Version Control System Interfaces
  -- All
     --- made the status LED (right lower corner) clickable (depending on
         overall VCS status it will show the log browser or the status dialog)
  -- Mercurial
     --- enhanced the tag dialog and extended the log browser to allow
         tagging of a specific revision
     --- added dialogs to enter the contents for initial .hgrc/mercurial.ini
         and .hg/hgrc files
     --- added a configuration option to enforce the usage of the internal
         merge tool
     --- made availablity of push/pull related actions dependent on configured
         remote repository (default/default-push in .hg/hgrc)
     --- extended the log browser by an action to switch to the selected
         revision
     --- added support for the shelve extension (as of Mercurial 2.8)
     --- added support for the largefiles extension (as of Mercurial 2.0)
     --- added support for Mercurial queues summary
     --- added support for various 'resolve' subcommands
- Third Party packages
  -- updated CharDet to 2.2.1

Version 5.4.0:
- bug fixes

Version 5.4.0-RC1:
- bug fixes
- General
  -- introduced a zoom widget in the status bar of several windows
  -- centralized the SSL error handling in E5SslErrorHandler
  -- moved the SSL widgets to the E5Network package
  -- changed the 'import' statements to improve startup behavior
  -- removed the QtHelp dependancy; support is only available,
     if the QtHelp module could be imported
  -- changed code to be compatible with latest PyQt4 Windows installers
  -- introduced a configurable delay timer to get smoother sidebars behavior
  -- added a specialized error message handler allowing to filter messages
  -- added commandline options '--start-file', '--start-multi' and
     '--start-project' to start with the most recently opened file,
     multi project or project
  -- added a dialog to show the most recent error log
- Debugger
  -- Debug Viewer
     --- added a viewer for the call stack leading to the current line
  -- Variables Viewer
     --- changed the way multi line strings are shown in the value
         column
- Checkers
  -- Coding Style (previously PEP-8)
     --- extended the coding style checker and its fixer
     --- added a checker for naming conventions
     --- added a checker for docstring conventions
     --- extended the fixer for docstring issues
- Editor
  -- added the capability to preview HTML, Markdown and ReST files
  -- added the capability to sort lines spanned by a rectangular selection
     based on the selected text
  -- added entires to convert the selection to upper/lower case to the
     edit menu
  -- changed the line numbers margin to adjust themselves to the size needed
  -- added support for virtual space
  -- added support to show the current class/method name in the combo boxes
     at the top of the editor
- File Browser
  -- added a JavaScript parser in order to show the structure of JavaScript
     files
- Mini Editor
  -- changed the line numbers margin to adjust themselves to the size needed
  -- added support for virtual space
- Multi Project
  -- extended the context menus of the multi project browser to be able
     to add projects this way
- Project
  -- added support for PyQt5 projects
- Project Viewer
  -- All
     --- added a context menu entry to delete the selected directory
  -- Forms Viewer
     --- added support for more widgets in the code creation dialog
     --- added a plug-in hook for the 'open' action
  -- Sources Viewer
     --- added support to highlight the current class/method name of the
         current editor
     --- added a JavaScript parser in order to show the structure of JavaScript
         files
  -- Translations Viewer
     --- added a plug-in hook for the 'open' action
- Shell
  -- changed the line numbers margin to adjust themselves to the size needed
- Symbols Viewer
  -- extended the list of supported unicode code blocks
- Template Viewer
  -- added a context menu entry to reload the templates
  -- changed logic such, that the templates are only written, if they contain
     some changes
- User Interface
  -- made the search and replace widgets scrollable (customisation for
     smaller screens)
- Version Control System Interfaces
  -- All
     --- added a confirmation dialog to the 'revert' actions
  -- Mercurial
     --- added a 'Copy Changesets' button to the log browser dialog
     --- editing the config file will generate a minimal one if none exists
     --- added support for the 'summary' command
     --- added capability to compare files side-by-side
  -- Subversion
     --- added capability to compare files side-by-side
     --- added cabaility to upgrade the working copy format
- Web Browser
  -- reworked the various SSL info widgets to show more info
  -- added a dialog to configure hosts to be exempted from caching
  -- added the capability to save the visible part of the current page
     as a screen shot
- Wizards
  -- added a wizard for the Qt5 QRegularExpression class (requires PyQt5)
  -- added support for PyQt5 to the QFileDialog wizard
- Third Party packages
  -- updated to Pygments 1.6

Version 5.3-snapshot-20130106:
- bug fixes
- General
  -- added support for Qt5 (experimental)
- Debugger
  -- added the capability to trace function calls and returns to the
     Python 2 and Python 3 debuggers
- Debug Viewer
  -- added a viewer for call trace logs
- Editor
  -- added actions to search for the next/previous occurence of the current
     word (default shortcuts Ctrl+. and Ctrl+,)
  -- added some icons to the "Languages" and "End-of-Line Type" context menus
- IRC
  -- added a simple IRC client
- Spell Checker
  -- added a dialog to edit the various spell checking dictionaries
- Syntax Checker
  -- added capability to the syntax checker dialog to show all errors/warnings
     in an editor when the file entry is double activated
- User Interface
  -- changed the layout of the right side widgets and added a sub menu
     for the switching between the 'inner' windows.
  -- added a notification system
- View Manager
  -- added actions to open the find in files and replace in files dialogs in a
     mode that searches open files only
  -- change the status labels for programming language and end-of-line type to
     show an icon

Version 5.3-snapshot-20121101:
- bug fixes
- General
  -- introduced a "workspace" directory that is used as the default for opening
     or saving new files or projects (configurable on Multiproject config page)
- Code Coverage
  -- enhanced the code coverage dialog functionality
- Configuration Dialog
  -- added a filter edit to filter the configuration tree
- Debug Viewer
  -- added the configurable capability to automatically show the source,
     when the call frame is changed in the callstack viewer of the local
     variables viewer
- Editor
  -- added capability to mark changed lines and to navigate between them
- Graphics Dialogs
  -- added capability to store and load diagrams to/from disk
  -- improved the package diagram to include subpackages and their module names
  -- added the capability to rebuild a diagram without losing the current item
     positions
- Plug-ins
  -- added the 'addSideWidget()' and 'removeSideWidget()' methods to the
     UserInterface class to allow plug-in developers to add a plug-in widget
     to the left or bottom side containers
- Project
  -- made the selectable project types of the project properties dialog
     dependent upon the selected programming language
- Version Control System Interfaces
  -- Mercurial
     --- added support for --log and --dry-run to the hg graft operation as of
         Mercurial 2.3.0
     --- added code to disable the (deprecated) transplant menu for
         Mercurial 2.3.0
- Web Browser
  -- added context menu entries for HTML5 media elements
  -- added a personal information manager to assist in completing form fields
     through field context menu entries or by pressing Ctrl+Return or
     Ctrl+Enter
  -- added support for GreaseMonkey scripts
  -- added an icon to the status bar to give direct access to AdBlock
  -- rewrote huge part of AdBlock to speed up
  -- added support for dependent AdBlock subscriptions
  -- added support for AdBlock exceptions
  -- added support for AdBlock checksum checking when downloading a
     subscription
  -- added support for variable AdBlock update periods (given in subscription)
  -- changed FTP support to use Python's ftplib instead of QFtp because the
     later is not supported in Qt5 anymore
  -- added a handler for file: schemes to allow directory listings

Version 5.3-snapshot-20120624:
- bug fixes
- General
  -- removed the user interface layout types "Floating Windows" and
     "Dock Windows"
- Log Viewer
  -- added the capability to search in the recorded log
- Shell
  -- added the capability to search in the output of the shell window
- Terminal
  -- added the capability to search in the output of the terminal window
- Version Control System Interfaces
  -- All
     --- added code to ensure, that some eric specific files and directories
         get ignored
     --- improved the copy/move operation a bit
  -- Mercurial
     --- added support for amending commits as of Mercurial 2.2
     --- added support for sub-repositories
  -- Subversion
     --- added capability to select from existing change lists and added a
         dialog to browse the change lists
- Web Browser
  -- extended the "Clear Private Data" dialog to clear flash cookies and
     to select a browsing history period to clear
  -- made the AdBlock update period configurable between 1 and 14 days

Version 5.3-snapshot-20120430:
- bug fixes
- Editor
  -- added capability to change the colours of the edit area independant from
     the colours of the system style
- Project
  -- added capability to save project tasks automatically (configurable on
     project configuration page of configuration dialog)
- Tasks
  -- changed the tasks handling to allow for more fine grained task
     designations
- Tools
  -- added a tool to take screenshots (fullscreen, selected screen, rectangular
     selection, elliptical selection or freehand selection)
- Version Control System Interfaces
  -- Mercurial
     --- added support for the graft command as of Mercurial 2.0
     --- added support for Phases as of Mercurial 2.1
  -- Subversion
     --- changed code to make the subversion plug-ins compatible with the new
         generation working copy meta-data format
- Web Browser
  -- extended the check for acceptable SSL certificates for indication via the
     URL entry field
  -- extended the web page context menu by several entries to send links or
     the selected text, handling the clicked frame, translate the selected
     text with Google Translate and search it in Wictionary
  -- extended the User Agent handling to be able to set the string on a host
     basis (next to the global user agent string)
  -- added code to save the current page as a screen shot
  -- added capability to synchronize bookmarks, history, passwords and user
     agent settings via an FTP server or a shared directory
  -- added the ClickToFlash plug-in to (temporarily) block Flash and related
     content
  -- added capability to suppress Referer Headers (configurable via eric4 Web
     Browser configuration page)
  -- added capability to select the first nine tabs by pressing Alt+1 to Alt+9
     and to switch to the last tab by pressing Alt+0
  -- added a Speed Dial to the web browser including the capability to select
     the first ten pages by pressing Meta+1 to Meta+0
  -- added a history sub-menu showing the most visited sites
  -- added the capability to restore closed tabs
  -- added a bookmarks importer to get them directly from other browsers files
  -- extended bookmarks to hold a description and various timestamps
  -- added capability to manage the QtHelp filter attributes
  -- added a page to the site info dialog to show web databases of the site
- Wizards
  -- QRegExp
     --- added support for the various pattern syntaxes
- Third Party packages
  -- updated to Pygments 1.5

Version 5.2.0:
- bug fixes
- Cooperation Functions
  -- added code to the cooperation functions to support IPv6
- Debugger
  -- extended debugger to show class variables
  -- extended debugger to ignore exceptions occuring in lines having a
     '__IGNORE_EXCEPTION__' line flag set
- Editor
  -- added an action to preview the file in the eric web browser. File name
     extension to support this feature can be configured on the
     Editor->Filehandling page
  -- added an action to the editor context menu and to the tabview and listview
     view managers to open an associated 'rejections' file (i.e. same file name
     with '.rej' appended)
  -- added an action to toggle block comments
  -- added a syntax check while typing function
  -- added source navigation function for Python 2, Python 3 and Ruby sources
  -- added support for QScintilla 2.6 (and newer)
  -- added capability to zoom by Ctrl + Mouse Wheel (same for the shell and
     terminal)
  -- added capability to zoom by a pinch gesture (same for the shell and
     terminal)
  -- added capability to go to method and class definitions by Shift + Mouse
     Wheel
  -- added the capability to replace just the selected occurence of the search
     text
- Plug-in Manager Tools
  -- added code to download and install plug-ins
- Source Browser
  -- show class attributes, class methods and static methods with different
     icons
  -- added context menu for attributes
- Source Documentor
  -- introduced separate sections for class methods and static methods
- Tasks Manager
  -- made tasks manager forget about global file tasks when file is closed
     (configurable via configuration dialog)
- Tools
  -- API files generator
     --- added code to write base class information to be used by the
         eric assistant plug-in
- Unit Test
  -- extended the unit test module to allow to rerun only failed tests of the
     last
- Version Control System Interfaces
  -- all
     --- made "Show Log" behave like "Show Limited Log" and removed the later
     --- added context menu actions to select/deselect all commitable items
         of the status dialogs
     --- added a file selector to the top of the diff dialogs to quickly jump
         to the diff for the selected file
  -- Mercurial
     --- added interface for the Mercurial command server (as of Mercurial 1.9)
     --- added code to support multiple revisions where appropriate
     --- modified pull such, that it will try to apply an existing changegroups
         file first (created by an hg incoming)
     --- added support for importing patches
     --- added support for exporting patches
     --- added configuration option to create backup files when reverting
         changes
- View Manager
  -- added an action to reset the zoom factor
- Web Browser
  -- added the "Do Not Track" feature
  -- added code to indicate invalid SSL certificates in the URL entry and the
     SSL info dialog
  -- added a dialog to show RSS feeds
  -- added a dialog to show some information about the current site
  -- added the capability to go through the history via Shift + Mouse Wheel
  -- added capability to zoom by a pinch gesture
- other enhancements
  -- added an action to launch another instantiation of eric5
  -- added capability to zoom by Ctrl + Mouse Wheel to various graphics
     related windows
  -- added capability to zoom by a pinch gesture to various graphics
     related windows

Version 5.2-snapshot-20110724:
- bug fixes
- enhancements of the Mercurial interface
  -- added support for the Mercurial bookmarks extension
  -- added support for the Mercurial queues extension
  -- added support for the Mercurial fetch extension
  -- added support for the Mercurial purge extension
  -- added support for the Mercurial gpg extension
  -- added support for the Mercurial transplant extension
  -- added support for the Mercurial rebase extension
  -- enhanced the Mercurial log browser dialog
- enhancements of the web browser
  -- added a pause button to the web browser download
  -- added some more user agent strings to the web browser
  -- added some more search engines to the web browser
  -- added capability to encrypt saved passwords with a master password
     and rearranged some configuration parameters related to security
  -- improved the handling of mouse XButton1 and XButton2 handling in the
     web browser
- enhancements of the configuration dialog
  -- added function to test the login data to the Email config page
- enhancements of the Unit Test module
  -- extended the unit test interface to support skipped tests, expected
     failures and unexpected successes and to better cope with Python2
     scripts when run from the eric IDE
- enhancements of the editor
  -- added editor actions to go to the last edit location and to the previous
     or next Python or Ruby class or method definition

Version 5.2-snapshot-20110501:
- bug fixes
- added menu entry for the icon editor to the tray starter
- added capability to filter out unwanted items in the file browsers
  (s. config dialog, interface page)
- changed syntax check to report error position within the line
- added functionality to the VCS status dialogs to make them more
  general commit dialogs
- extended the Mercurial log browser to indicate closed branches
- changed the configuration dialog to remember the last show page name
- added configuration options for visible whitespace (as of QScintilla 2.5)
- added capability to configure the alpha channel for some colors
  (as of QScintilla 2.5)
- added support for new lexer properties (as of QScintilla 2.5)
- added support for access keys and drag & drop to the web browser
- added support for search schemes ("s:" or "search:") and "about:home" to
  the web browser
- added capability to the tasks viewer to ignore files based on a wildcard
  during a project tasks scan
- added an action to push a new named branch to the Mercurial plug-in
- added an interface to VirusTotal to the web browser
- changed algorithm to determine the debugger backend type to be used by
  analysing a first line starting with '#!'
- added support for the Matlab and Octave lexers for QScintilla >= 2.5.1
- enhanced the autocompletion of templates to observe the language of the
  current file
- added support for "hg rollback" to the Mercurial interface

Version 5.1-snapshot-20110123:
- bug fixes
- made the toolbars of the initial layout more minimalistic
- merged "Save to Project" into "Save" and "Save As...".
- added a checker for PEP 8 compliance (including a fixer for
  most issues)

Version 5.1-snapshot-20110106:
- bug fixes
- added support for the display of inline annotations (used to show
  syntax errors and warnings)
- added support for additional configurable file filters
- added a certificate manager to the eric web browser
- added display of suppressed client termination messages
- changed the Mercurial log browser to show incoming/outgoing changesets
  with the current log (by pressing the next button)
- added a feature where flags can be given at the end of a source file.
  The only flag supported is 'FileType' to overwrite the filetype detection
  mechanism.
- added a syntax checker function for Python 2 files
- added a pyflakes checker function for Python 2 files
- added a tabnanny checker function for Python 2 files
- updated Pygments to version 1.4.0

Version 5.1-snapshot-20101029:
- bug fixes
- added configuration options for the web browser cache policy
- added tab previews to the web browser
- added a line widget with embeddable buttons
- changed the web browser to give it a more modern look
- added code to show certificate info for https URLs
- added a download manager to the web browser
- added a check to the find and replace dialog to make sure,
  that no external changes were done between the find run and
  the replace run
- added an option to configure the icon of the tray starter application
- updated Pygments to version 1.3.1

Version 5.1-snapshot-20100918:
- bug fixes
- converted all signal/slot code to use the new API
- added action to copy the editor path to the clipboard to the tab context menu
- added code to adjust the cursor flash time of the editor to the global
  settings
- added code to show hidden files in the various browsers
- added an editor action to join the current line with the next one
- added code to cope with Linux distributor's usage of KDE wrapper dialogs
  for the Qt file dialogs
- added a source code exporter for the Open Document Text (ODT) format
- changed all calls to QMessageBox to some eric5 replacements and convenience
  functions
- added a wizard for the eric5 message box (E5MessageBox)
- added filename filters to the code metrics, syntax checker and tabnanny
  dialogs
- changed XML handling code to use QXmlStreamReader and QXmlStreamWriter
- added use of compositing modes to the icon editor
- modified install script such, that it allows an installation from source as
  well. The situation will be determined automatically.

Version 5.1-snapshot-20100718:
- bug fixes
- added an action to perform a 'hg push -f' to the Mercurial plug-in
- added a handler for ftp: URLs to the web browser
- added action to start a Mercurial server to the Mercurial plug-in
- added action to print to PDF to the web browser
- added a branch filter to the Mercurial log browser
- added additional fold styles
- added capability to configure the colors of the foldmarkers
- added option to use DNS prefetching to the web browser (needs Qt >= 4.6)
- added support for Web SQL Databases to the web browser
- added support for Web application caches and local web storage to the
  web browser (needs Qt >= 4.6)
- added a symbols viewer with capability to insert the selected symbol
  by double-clicking it
- added a numbers viewer to convert numbers into various formats
- extended the Ad-Blocker of the web browser (needs Qt >= 4.6)
- added capability to configure the text encoding of the web browser 
  (needs Qt >= 4.6)
- added capability to select the user agent string for the web browser

Version 5.0-snapshot-20100523:
- bug fixes
- added code to save the editor zoom factor in the session file
- added code to configure the zoom factor a file is opened with
- added code to update the file browser window (mostly) automatically
- added code to update the Others tab of the project browser (mostly)
  automatically
- added a menu to the highlighting styles config page to change individual
  aspects of a font only
- changed code to improve development on multiple platforms
- added code to show the keyboard shortcut to the tooltip of an action
- changed the Find in Files dialog to remember the history of the search
  string, replace string and the search directory
- added code to enhance the proxy configuration and removed the usage of QHttp

Version 5.0-snapshot-20100508:
- bug fixes
- added administration actions to the Mercurial plug-in
- added changegroup related actions to the Mercurial plug-in
- added bisect commands to the Mercurial plug-in

Version 5.0-snapshot-20100418:
- bug fixes
- added plugin for Mercurial version control system

Version 5.0-snapshot-20100401:
- bug fixes
- added installation of a .desktop file for Linux systems
- added shared editor functions and a simple chat system

Version 5.0-snapshot-20100306:
- bug fixes
- added code to indicate directories and files being symbolic links
- extendend the predefined template variables by "project_path",
  "clipboard", "cur_select", "insertion", "select_start" and
  "select_end"
- added the auto fork options to the run dialog
- added capability to change the keywords of a syntax highlighter

Version 5.0-snapshot-20100206:
- bug fixes
- added code to use the PYTHONPATH environment setting in the debuggers
- added my own Python3 port of pyflakes
- integrated py3flakes into syntax checker dialog and editor

Version 5.0-snapshot-20100116:
- first snapshot of eric5
